org.optaplanner.core.impl.domain.variable.inverserelation

## Class ExternalizedSingletonInverseVariableSupply

- java.lang.Object
- - org.optaplanner.core.impl.domain.variable.inverserelation.ExternalizedSingletonInverseVariableSupply

- All Implemented Interfaces:
    SingletonInverseVariableSupply, StatefulVariableListener<Object>, VariableListener<Object>, Supply

      public class ExternalizedSingletonInverseVariableSupply
      extends Object
      implements StatefulVariableListener<Object>, SingletonInverseVariableSupply

  Alternative to `SingletonInverseVariableListener`.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Map<Object,Object>` | `inverseEntityMap`
    `protected VariableDescriptor` | `sourceVariableDescriptor`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExternalizedSingletonInverseVariableSupply(VariableDescriptor sourceVariableDescriptor)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterEntityAdded(ScoreDirector scoreDirector, Object entity)`
    `void` | `afterEntityRemoved(ScoreDirector scoreDirector, Object entity)`
    `void` | `afterVariableChanged(ScoreDirector scoreDirector, Object entity)`
    `void` | `beforeEntityAdded(ScoreDirector scoreDirector, Object entity)`
    `void` | `beforeEntityRemoved(ScoreDirector scoreDirector, Object entity)`
    `void` | `beforeVariableChanged(ScoreDirector scoreDirector, Object entity)`
    `void` | `clearWorkingSolution(ScoreDirector scoreDirector)`
    `Object` | `getInverseSingleton(Object value)` If entity1.varA = x then the inverse of x is entity1.
    `VariableDescriptor` | `getSourceVariableDescriptor()`
    `protected void` | `insert(ScoreDirector scoreDirector, Object entity)`
    `void` | `resetWorkingSolution(ScoreDirector scoreDirector)`
    `protected void` | `retract(ScoreDirector scoreDirector, Object entity)`
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.domain.variable.listener.VariableListener

      `requiresUniqueEntityEvents`

- - ### Field Detail

    - #### sourceVariableDescriptor

          protected final VariableDescriptor sourceVariableDescriptor

    - #### inverseEntityMap

          protected Map<Object,Object> inverseEntityMap

  - ### Constructor Detail

    - #### ExternalizedSingletonInverseVariableSupply

          public ExternalizedSingletonInverseVariableSupply(VariableDescriptor sourceVariableDescriptor)

  - ### Method Detail

    - #### getSourceVariableDescriptor

          public VariableDescriptor getSourceVariableDescriptor()

      Specified by:
        `getSourceVariableDescriptor` in interface `StatefulVariableListener<Object>`

    - #### resetWorkingSolution

          public void resetWorkingSolution(ScoreDirector scoreDirector)

      Specified by:
        `resetWorkingSolution` in interface `StatefulVariableListener<Object>`

    - #### clearWorkingSolution

          public void clearWorkingSolution(ScoreDirector scoreDirector)

      Specified by:
        `clearWorkingSolution` in interface `StatefulVariableListener<Object>`

    - #### beforeEntityAdded

          public void beforeEntityAdded(ScoreDirector scoreDirector,
                                        Object entity)

      Specified by:
        `beforeEntityAdded` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterEntityAdded

          public void afterEntityAdded(ScoreDirector scoreDirector,
                                       Object entity)

      Specified by:
        `afterEntityAdded` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### beforeVariableChanged

          public void beforeVariableChanged(ScoreDirector scoreDirector,
                                            Object entity)

      Specified by:
        `beforeVariableChanged` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterVariableChanged

          public void afterVariableChanged(ScoreDirector scoreDirector,
                                           Object entity)

      Specified by:
        `afterVariableChanged` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### beforeEntityRemoved

          public void beforeEntityRemoved(ScoreDirector scoreDirector,
                                          Object entity)

      Specified by:
        `beforeEntityRemoved` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterEntityRemoved

          public void afterEntityRemoved(ScoreDirector scoreDirector,
                                         Object entity)

      Specified by:
        `afterEntityRemoved` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### insert

          protected void insert(ScoreDirector scoreDirector,
                                Object entity)

    - #### retract

          protected void retract(ScoreDirector scoreDirector,
                                 Object entity)

    - #### getInverseSingleton

          public Object getInverseSingleton(Object value)

      Description copied from interface: `SingletonInverseVariableSupply`
      If entity1.varA = x then the inverse of x is entity1.
      Specified by:
        `getInverseSingleton` in interface `SingletonInverseVariableSupply`
      Parameters:
        `value` - never null
      Returns:
        sometimes null, an entity for which the planning variable is the planningValue.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2006–2020 JBoss by Red Hat. All rights reserved.